#include <windows.h>
#include <stdarg.h>
#include <time.h>
#include <stdio.h>

#pragma comment(lib, "advapi32.lib")
#pragma comment(lib, "user32.lib")

#define MYNAME "Check SuperCache II"

char g_szVolumeKey[260] = "SYSTEM\\CurrentControlSet\\Enum\\STORAGE\\Volume";

int ProcessEachVolume(char *szVolumeName)
{
    HKEY hk;                      // registry key handle
    LONG nRC;
    DWORD dwIndex;
    char szKeyName[1024];
    char szName[1024];
    DWORD dwNameLen;
    char szMessage[1024];

    sprintf(szKeyName, "%s\\%s\\Device Parameters\\SscVF", g_szVolumeKey, szVolumeName);
    nRC = RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKeyName, 0, KEY_ALL_ACCESS, &hk);
    if (nRC != ERROR_SUCCESS) {
        // we don't need to process it when the subkey not exist
        if (nRC == 2) {// not exist
            return 0;
        }
        sprintf(szMessage, "RegOpenKeyEx() failed %lx for HKLM %s", nRC, szKeyName);
        MessageBox(NULL, szMessage, MYNAME, MB_OK);
        return 0;
    }

    dwIndex = 0;
    while (1) {
        dwNameLen = 1024;
        nRC = RegEnumValue(hk, dwIndex, szName, &dwNameLen, NULL, NULL, NULL, NULL);
        if (nRC != ERROR_SUCCESS) {
            if (nRC == ERROR_NO_MORE_ITEMS)
                break;
            sprintf(szMessage, "RegEnumValue() failed %lx for %s, Value %s", nRC, szKeyName, szName);
            MessageBox(NULL, szMessage, MYNAME, MB_OK);
            break;
        }
        dwIndex++;
    }
    RegCloseKey(hk);

    if (dwIndex > 0) {
        sprintf(szMessage, "SSCVF Value still exist %d, it may cause the system hang during booting!", dwIndex);
        MessageBox(NULL, szMessage, MYNAME, MB_OK);
    }
    return 0;
}

int CheckSSCVFKey(void)
{
    HKEY hk;
    LONG nRC;
    DWORD dwIndex;
    char szName[1024];
    DWORD dwNameLen;
    FILETIME ftTime;
    char szMessage[1024];

    nRC = RegOpenKeyEx(HKEY_LOCAL_MACHINE, g_szVolumeKey, 0, KEY_ENUMERATE_SUB_KEYS, &hk);
    if (nRC != ERROR_SUCCESS) {
        sprintf(szMessage, "RegOpenKeyEx() failed %lx for HKLM %s", nRC, g_szVolumeKey);
        MessageBox(NULL, szMessage, MYNAME, MB_OK);
        return 1;
    }

    dwIndex = 0;
    while (1) {
        dwNameLen = 1024;
        nRC = RegEnumKeyEx(hk, dwIndex, szName, &dwNameLen, NULL, NULL, NULL, &ftTime);
        if (nRC != ERROR_SUCCESS) {
            if (nRC == ERROR_NO_MORE_ITEMS) break;
            sprintf(szMessage, "RegEnumKeyEx() failed %lx for HKLM %s", nRC, g_szVolumeKey);
            MessageBox(NULL, szMessage, MYNAME, MB_OK);
            break;
        }
        ProcessEachVolume(szName);
        dwIndex++;
    }
    RegCloseKey(hk);
    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    CheckSSCVFKey();
    //MessageBox(NULL, "Check Finished", MYNAME, MB_OK);
    return 0;
}

